# Retrieve customer

Use the **getCustomerInformation** method to retrieve the details of a customer entity from the 2Checkout system.

## Request parameters

<table><thead><tr><th width="252.4000244140625">Parameter</th><th>Type / Description</th></tr></thead><tbody><tr><td><code>sessionID</code></td><td><strong>Required (string)</strong><br>Session identifier, the output of the <strong>Login</strong> method. Include <code>sessionID</code> into all your requests. 2Checkout throws an exception if the values are incorrect. The <code>sessionID</code> expires in <strong>10 minutes</strong>.</td></tr><tr><td><code>CustomerReference</code></td><td><strong>Required (int)</strong><br>System-generated customer reference. Required unless you prefer to use <code>ExternalCustomerReference</code>.</td></tr><tr><td><code>ExternalCustomerReference</code></td><td><strong>Optional (string)</strong><br>External customer reference that you control. Optional when you use <code>CustomerReference</code>. If you include it, it needs to belong to the same customer as the <code>CustomerReference</code>.</td></tr><tr><td><code>IncludePaymentData</code></td><td><strong>Boolean</strong><br>Indicates if the customer payment data should be returned within the ExistingCards property. Default value is <strong>FALSE</strong>.</td></tr></tbody></table>

### Request sample

```php
<?php

declare(strict_types=1);

class Configuration
{
    public const MERCHANT_CODE = 'MERCHANT_CODE';
    public const MERCHANT_KEY = 'SECRET_KEY';
    public const URL = 'http://api.2checkout.com/soap/6.0';
    public const ACTION = 'getCustomerInformation';
    public const CUSTOMER_REF = '1111';
    public const INCLUDE_PAYMENT_DATA = true;
    //array or JSON
    public const PAYLOAD = null;

}

class Client
{
    public function call(
        string $url = Configuration::URL,
        $payload = Configuration::PAYLOAD,
        string $action = Configuration::ACTION
    ): ?object {
        if (is_array($payload)) {
            $payload = json_encode($payload);
        }
        if (!empty($payload)) {
            // SoapClient works with objects(StdClass)
            $payload = json_decode($payload);
        }
        $soapClient = $this->getClient($url);
        $sessionId = $this->getSession($soapClient);
        $args = array_filter([$sessionId, Configuration::CUSTOMER_REF, Configuration::CUSTOMER_REF, Configuration::INCLUDE_PAYMENT_DATA, $payload]);

        return $soapClient->$action(...$args);
    }

    public function getClient(string $url): SoapClient
    {
        return new SoapClient(
            $url . '?wsdl',
            [
                'location'   => $url,
                'cache_wsdl' => WSDL_CACHE_NONE,
            ]
        );
    }

    public function getSession(SoapClient $client)
    {
        $date = gmdate('Y-m-d H:i:s');
        $merchantCode = Configuration::MERCHANT_CODE;
        $key = Configuration::MERCHANT_KEY;
        $string = strlen($merchantCode) . $merchantCode . strlen($date) . $date;
        $algo = 'sha256';
        $hash = hash_hmac($algo, $string, $key);
        $client->__setCookie('XDEBUG_SESSION', 'PHPSTORM');

        return $client->login($merchantCode, $date, $hash, $algo);
    }
}

try {
    $client = new Client();
    var_dump($client->call());
} catch (Exception $ex) {
    var_dump($ex);
}
```

## Response parameters

<table><thead><tr><th width="124.4000244140625">Parameter</th><th>Type</th></tr></thead><tbody><tr><td><a href="/pages/l51iTomfeHH2OmdQbRlz"><code>Customer</code></a></td><td><strong>Object</strong></td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.2checkout.com/soap-api-reference/soap-api-6.0/api-requests/customer/retrieve-customer.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
